package com.mortals.xhx.module.appointment.web;
import com.mortals.framework.common.Rest;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.common.code.EnabledEnum;
import com.mortals.xhx.common.code.YesNoEnum;
import com.mortals.xhx.module.device.model.DeviceEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.appointment.model.AppointmentRecordsEntity;
import com.mortals.xhx.module.appointment.service.AppointmentRecordsService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import com.alibaba.fastjson.JSONObject;
import java.util.Arrays;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import static com.mortals.framework.ap.SysConstains.*;
/**
*
* 预约签到记录
*
* @author zxfei
* @date 2023-04-09
*/
@RestController
@RequestMapping("appointment/records")
public class AppointmentRecordsController extends BaseCRUDJsonBodyMappingController<AppointmentRecordsService,AppointmentRecordsEntity,Long> {

    @Autowired
    private ParamService paramService;

    public AppointmentRecordsController(){
        super.setModuleDesc( "预约签到记录");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "checkInMethod", paramService.getParamBySecondOrganize("AppointmentRecords","checkInMethod"));
        super.init(model, context);
    }


    /**
     * 群众停止服务
     */
    @PostMapping(value = "stopService")
    public String stopService(@RequestBody AppointmentRecordsEntity appointmentRecordsEntity) {
        JSONObject jsonObject = new JSONObject();
        Map<String, Object> model = new HashMap<>();
        String busiDesc = this.getModuleDesc() + "停止服务";
        try {
            Rest<String> rest = this.service.stopService(appointmentRecordsEntity, getContext());
            if(YesNoEnum.YES.getValue()==rest.getCode()){
                recordSysLog(request, busiDesc  + " 【成功】");
                jsonObject.put(KEY_RESULT_DATA, model);
                jsonObject.put(KEY_RESULT_CODE, VALUE_RESULT_SUCCESS);
                jsonObject.put(KEY_RESULT_MSG, rest.getMsg());
            }else {
                throw new AppException(rest.getMsg());
            }
        } catch (Exception e) {
            log.error(busiDesc, e);
            jsonObject.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            jsonObject.put(KEY_RESULT_MSG, super.convertException(e));
        }
        return jsonObject.toJSONString();
    }


}